'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');

const bpSdkNextButtonCss = "";

let BpSdkNextButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.navigateNext = index.createEvent(this, "navigateNext", 7);
    /**
     * Forward button text
     */
    this.text = '';
    /**
     * Icon name
     */
    this.icon = 'chevron-right';
    /**
     * Controls disabled state of button
     */
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-next-button');
    customElements.whenDefined('bp-sdk-external-next-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-next-button", { buttonDisabled: this.buttonDisabled, cssClasses: this.cssClasses, icon: this.icon, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-next-button__container" }, index.h("bp-sdk-button", { onClick: () => this.navigateNext.emit(), text: this.text, buttonDisabled: this.buttonDisabled, class: this.cssClasses }, index.h("bp-sdk-icon-container", { name: this.icon }))));
  }
};
BpSdkNextButton.style = bpSdkNextButtonCss;

exports.bp_sdk_next_button = BpSdkNextButton;
