'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');

const bpSdkStepperGroupCss = "";

let BpSdkStepperGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-stepper-group');
    customElements.whenDefined('bp-sdk-external-stepper-group').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderAnswers(questionGroup) {
    var _a;
    return (_a = questionGroup === null || questionGroup === void 0 ? void 0 : questionGroup.answers) === null || _a === void 0 ? void 0 : _a.map((answer) => {
      if (this.displayAsQuestionGroup(answer.id)) {
        const nestedGroup = this.questionGroup.nestedGroupsWithAnswers.get(answer.id);
        if (nestedGroup.answers.length > 0) {
          return index.h("bp-sdk-stepper-group", { questionGroup: nestedGroup });
        }
        return index.h("bp-sdk-stepper-group", { questionGroup: this.questionGroup.nestedGroupsWithAnswers.get(answer.id) });
      }
      else {
        return (index.h("bp-sdk-dynamic-input-redux-container", { answer: answer, labelledBy: "", id: `bp-sdk-question-group__${answer.question.id}`, class: "bp-sdk-question-group__question-set" }));
      }
    });
  }
  renderExternal() {
    return index.h("bp-sdk-external-stepper-group", { questionGroup: this.questionGroup });
  }
  renderInternal() {
    return index.h("div", { class: "bp-sdk-stepper-group__container" }, this.renderAnswers(this.questionGroup));
  }
  displayAsQuestionGroup(id) {
    return this.questionGroup.nestedGroupsWithAnswers.has(id);
  }
};
BpSdkStepperGroup.style = bpSdkStepperGroupCss;

const bpSdkStepperGroupButtonCss = "";

let BpSdkStepperGroupButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Controls disabled state of button
     */
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-stepper-group-button');
    customElements.whenDefined('bp-sdk-external-stepper-group-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-stepper-group-button", { answer: this.answer, direction: this.direction, buttonDisabled: this.buttonDisabled, handleStepperButtonClick: this.handleStepperButtonClick }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-stepper-group-button__container" }, this.answer && (index.h("button", { type: "button", class: "bp-sdk-stepper-group-button__button", disabled: this.buttonDisabled, onClick: () => this.handleStepperButtonClick(this.answer, this.direction) }, this.answer.question.text))));
  }
};
BpSdkStepperGroupButton.style = bpSdkStepperGroupButtonCss;

exports.bp_sdk_stepper_group = BpSdkStepperGroup;
exports.bp_sdk_stepper_group_button = BpSdkStepperGroupButton;
