import { Component, h, Prop, State, Event } from '@stencil/core';
export class BpSdkQuoteRequestButtonContainer {
  constructor() {
    /**
     * Annual Price
     */
    this.annualPrice = '0';
    /**
     * Application form id
     */
    this.appFormId = '';
    /**
     * Quote id
     */
    this.quoteId = '';
    this.useExternal = false;
    this.handleAfterBindResponse = (quoteWindow) => (response) => {
      quoteWindow.location.href = response;
    };
    this.onBind = () => {
      const quoteWindow = window.open('about:blank', '_blank');
      this.quoteWindow = quoteWindow;
      this.handleBind(this.quoteId, this.appFormId, this.handleAfterBindResponse(quoteWindow));
      this.bpAnalyticsTrack.emit({
        eventName: 'ButtonClick',
        eventPayload: {
          label: 'Update Selection',
          value: this.annualPrice,
          dataValue: `${this.carrierName}_${this.annualPrice}`,
        },
      });
    };
  }
  resetState() {
    this.quoteWindow = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-button-container');
    customElements.whenDefined('bp-sdk-external-quote-request-button-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-button-container", { annualPrice: this.annualPrice, appFormId: this.appFormId, carrierName: this.carrierName, handleBind: this.handleBind, quoteId: this.quoteId }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-button-container__container bp-sdk-online-quote__bind bp-sdk-quote__bind" },
      h("bp-sdk-quote-request-button", { onClick: this.onBind, text: "Bind" })));
  }
  static get is() { return "bp-sdk-quote-request-button-container"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-quote-request-button-container.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-quote-request-button-container.css"]
  }; }
  static get properties() { return {
    "annualPrice": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Annual Price"
      },
      "attribute": "annual-price",
      "reflect": false,
      "defaultValue": "'0'"
    },
    "appFormId": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Application form id"
      },
      "attribute": "app-form-id",
      "reflect": false,
      "defaultValue": "''"
    },
    "carrierName": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Carrier name"
      },
      "attribute": "carrier-name",
      "reflect": false
    },
    "handleBind": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "HandleBindFunction",
        "resolved": "(quoteId: string, appFormId: string, afterResponse?: (response: string) => void) => void",
        "references": {
          "HandleBindFunction": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "quote bind function"
      }
    },
    "quoteId": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Quote id"
      },
      "attribute": "quote-id",
      "reflect": false,
      "defaultValue": "''"
    }
  }; }
  static get states() { return {
    "useExternal": {},
    "quoteWindow": {}
  }; }
  static get events() { return [{
      "method": "bpAnalyticsTrack",
      "name": "bpAnalyticsTrack",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "complexType": {
        "original": "IAnalyticsTrackEventDetail",
        "resolved": "IAnalyticsTrackEventDetail",
        "references": {
          "IAnalyticsTrackEventDetail": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      }
    }]; }
}
