import { r as registerInstance, h } from './index-b4e0290f.js';
import { u, t } from './index.esm.min-5e144817.js';
import { i as ix } from './index.esm.min-a0c9e6cc.js';

const bpSdkAccumulationQuestionGroupCss = "[name='evanston_activity_inventory_percentage_total']{visibility:hidden}[name='evanston_activity_inventory_percentage_total']+bp-sdk-errors-container{display:none}";

let BpSdkAccumulationQuestionGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Answers
     */
    this.answers = [];
    /**
     * Warning message
     */
    this.warning = 'Percent of total operations must equal 100%';
    this.showAccumulatorWarning = false;
    this.showAccumulatorErrors = false;
    this.useExternal = false;
  }
  onAnswersChange(answers) {
    this.accumulator = (answers || []).find((answer) => { var _a; return ((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.reference_type) === u.Accumulator; });
  }
  onAccumulatorChange(accumulator) {
    const buffer = parseInt(accumulator === null || accumulator === void 0 ? void 0 : accumulator.value, 10);
    this.buffer = isNaN(buffer) ? undefined : buffer;
    this.showAccumulatorWarning = this.validateAccumulatorValue();
  }
  onAccumulatorErrorsChange({ detail }) {
    this.showAccumulatorErrors = detail.length > 0;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-accumulation-question-group');
    customElements.whenDefined('bp-sdk-external-accumulation-question-group').then(() => {
      this.useExternal = true;
    });
    this.onAnswersChange(this.answers);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-accumulation-question-group", { answers: this.answers, label: this.label, labelledBy: this.labelledBy, warning: this.warning }));
  }
  shouldHideLabel(answer) {
    var _a, _b;
    return (((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.field_type) === t.CheckBox || ((_b = answer === null || answer === void 0 ? void 0 : answer.question) === null || _b === void 0 ? void 0 : _b.reference_type) === u.Accumulator);
  }
  getAriaLabel(answer) {
    var _a;
    return ((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.field_type) === t.CheckBox ? answer.question.text : undefined;
  }
  validateAccumulatorValue() {
    var _a;
    if ((_a = this.accumulator) === null || _a === void 0 ? void 0 : _a.value) {
      return this.buffer < this.accumulator.question.min_value || this.buffer > this.accumulator.question.max_value;
    }
    return false;
  }
  renderInternal() {
    var _a;
    return (h("div", { class: "bp-sdk-accumulation-question-group__container" }, h("div", { class: "bp-sdk-accumulation-question-group__wrapper" }, h("div", { class: "bp-sdk-accumulation-question-set__header" }, h("bp-sdk-progress", { label: "Question group progress", value: this.buffer }), h("div", null, ((_a = this.accumulator) === null || _a === void 0 ? void 0 : _a.value) && (h("h2", { "aria-live": "assertive", class: "bp-sdk-accumulation-question-set__value" }, this.accumulator.value, "%")), this.showAccumulatorErrors && h("h4", { class: "bp-sdk-accumulation-question-set__error" }, this.warning), this.showAccumulatorWarning && !this.showAccumulatorErrors && (h("h4", { class: "bp-sdk-accumulation-question-set__warning" }, this.warning)))), this.answers.map((answer) => (h("bp-sdk-dynamic-input-redux-container", { class: ix('', {
        'bp-sdk-indent': answer.question.reference_type === u.Indent,
      }), answer: answer, shouldHideLabel: this.shouldHideLabel(answer), "aria-label": this.getAriaLabel(answer), isAccumulatorAnswer: answer.question.reference_type === u.Accumulator }))))));
  }
  static get watchers() { return {
    "answers": ["onAnswersChange"],
    "accumulator": ["onAccumulatorChange"]
  }; }
};
BpSdkAccumulationQuestionGroup.style = bpSdkAccumulationQuestionGroupCss;

const bpSdkProgressCss = "";

let BpSdkProgress = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-progress');
    customElements.whenDefined('bp-sdk-external-progress').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-progress", { label: this.label, value: this.value });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-progress__container" }, h("progress", { class: "bp-sdk-progress__bar", value: this.value, "aria-label": this.label })));
  }
};
BpSdkProgress.style = bpSdkProgressCss;

export { BpSdkAccumulationQuestionGroup as bp_sdk_accumulation_question_group, BpSdkProgress as bp_sdk_progress };
