import { r as registerInstance, h, c as createEvent } from './index-b4e0290f.js';
import { o as ox } from './index.esm.min-a0c9e6cc.js';

const bpSdkQuoteRequestBindContainerCss = "";

let BpSdkQuoteRequestBindContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Application form id
     */
    this.appFormId = '';
    /**
     * Quote id
     */
    this.quoteId = '';
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-bind-container');
    customElements.whenDefined('bp-sdk-external-quote-request-bind-container').then(() => {
      this.useExternal = true;
    });
    this.onQuoteInfoChange(this.quoteInfo);
    this.onCarrierChange(this.carrier);
  }
  onQuoteInfoChange(quoteInfo) {
    var _a;
    this.annualPrice = (_a = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.annual_price) !== null && _a !== void 0 ? _a : '0';
  }
  onCarrierChange(carrier) {
    var _a;
    this.carrierName = (_a = carrier === null || carrier === void 0 ? void 0 : carrier.name) !== null && _a !== void 0 ? _a : '';
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-bind-container", { appFormId: this.appFormId, carrier: this.carrier, isBindable: this.isBindable, quoteId: this.quoteId, quoteInfo: this.quoteInfo, handleBind: this.handleBind }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-bind-container__container" }, this.isBindable && (h("bp-sdk-quote-request-button-container", { annualPrice: this.annualPrice, appFormId: this.appFormId, carrierName: this.carrierName, quoteId: this.quoteId, handleBind: this.handleBind }))));
  }
  static get watchers() { return {
    "quoteInfo": ["onQuoteInfoChange"],
    "carrier": ["onCarrierChange"]
  }; }
};
BpSdkQuoteRequestBindContainer.style = bpSdkQuoteRequestBindContainerCss;

const bpSdkQuoteRequestButtonContainerCss = "";

let BpSdkQuoteRequestButtonContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bpAnalyticsTrack = createEvent(this, "bpAnalyticsTrack", 7);
    /**
     * Annual Price
     */
    this.annualPrice = '0';
    /**
     * Application form id
     */
    this.appFormId = '';
    /**
     * Quote id
     */
    this.quoteId = '';
    this.useExternal = false;
    this.handleAfterBindResponse = (quoteWindow) => (response) => {
      quoteWindow.location.href = response;
    };
    this.onBind = () => {
      const quoteWindow = window.open('about:blank', '_blank');
      this.quoteWindow = quoteWindow;
      this.handleBind(this.quoteId, this.appFormId, this.handleAfterBindResponse(quoteWindow));
      this.bpAnalyticsTrack.emit({
        eventName: 'ButtonClick',
        eventPayload: {
          label: 'Update Selection',
          value: this.annualPrice,
          dataValue: `${this.carrierName}_${this.annualPrice}`,
        },
      });
    };
  }
  resetState() {
    this.quoteWindow = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-button-container');
    customElements.whenDefined('bp-sdk-external-quote-request-button-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-button-container", { annualPrice: this.annualPrice, appFormId: this.appFormId, carrierName: this.carrierName, handleBind: this.handleBind, quoteId: this.quoteId }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-button-container__container bp-sdk-online-quote__bind bp-sdk-quote__bind" }, h("bp-sdk-quote-request-button", { onClick: this.onBind, text: "Bind" })));
  }
};
BpSdkQuoteRequestButtonContainer.style = bpSdkQuoteRequestButtonContainerCss;

const bpSdkQuoteRequestHeaderCss = "";

let BpSdkQuoteRequestHeader = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-header');
    customElements.whenDefined('bp-sdk-external-quote-request-header').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-header", { carrier: this.carrier, customLogoBaseUrl: this.customLogoBaseUrl, name: this.name, showCustomLogo: this.showCustomLogo, showLogo: this.showLogo }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-header__container bp-sdk-online-quote__header bp-sdk-quote__header" }, h("div", { class: "bp-sdk-online-quote__carrier bp-sdk-quote__carrier" }, h("h1", { class: "bp-sdk-online-quote__carrier-name bp-sdk-quote__carrier-name" }, this.name), h("bp-sdk-quote-request-logo-container", { carrier: this.carrier, customLogoBaseUrl: this.customLogoBaseUrl, showCustomLogo: this.showCustomLogo, showLogo: this.showLogo }))));
  }
};
BpSdkQuoteRequestHeader.style = bpSdkQuoteRequestHeaderCss;

const bpSdkQuoteRequestHeaderContainerCss = "";

let BpSdkQuoteRequestHeaderContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-header-container');
    customElements.whenDefined('bp-sdk-external-quote-request-header-container').then(() => {
      this.useExternal = true;
    });
    this.onCarrierChange(this.carrier);
  }
  onCarrierChange(carrier) {
    this.name = carrier === null || carrier === void 0 ? void 0 : carrier.name;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-header-container", { carrier: this.carrier, customLogoBaseUrl: this.customLogoBaseUrl, showCustomLogo: this.showCustomLogo, showLogo: this.showLogo }));
  }
  renderInternal() {
    return (h("bp-sdk-quote-request-header", { carrier: this.carrier, customLogoBaseUrl: this.customLogoBaseUrl, name: this.name, showCustomLogo: this.showCustomLogo, showLogo: this.showLogo }));
  }
  static get watchers() { return {
    "carrier": ["onCarrierChange"]
  }; }
};
BpSdkQuoteRequestHeaderContainer.style = bpSdkQuoteRequestHeaderContainerCss;

const bpSdkQuoteRequestPremiumCss = "";

let BpSdkQuoteRequestPremium = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-premium');
    customElements.whenDefined('bp-sdk-external-quote-request-premium').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-premium", { annualPrice: this.annualPrice, downpayment: this.downpayment, installments: this.installments, monthlyPrice: this.monthlyPrice, price: this.price, showTotalPremium: this.showTotalPremium, termLength: this.termLength, totalPremium: this.totalPremium }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-premium__container bp-sdk-online-quote__price-container bp-sdk-quote__price-container" }, h("div", { class: "bp-sdk-online-quote__price-body bp-sdk-quote__price-body" }, h("bp-sdk-quote-request-premium-term", { price: this.price, showTotalPremium: this.showTotalPremium, termLength: this.termLength, totalPremium: this.totalPremium }), !!this.monthlyPrice && (h("bp-sdk-quote-request-premium-monthly", { annualPrice: this.annualPrice, downpayment: this.downpayment, installments: this.installments, monthlyPrice: this.monthlyPrice })))));
  }
};
BpSdkQuoteRequestPremium.style = bpSdkQuoteRequestPremiumCss;

const bpSdkQuoteRequestPremiumContainerCss = "";

let BpSdkQuoteRequestPremiumContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-premium-container');
    customElements.whenDefined('bp-sdk-external-quote-request-premium-container').then(() => {
      this.useExternal = true;
    });
    this.onQuoteInfoChange(this.quoteInfo);
  }
  onQuoteInfoChange(quoteInfo) {
    var _a;
    this.annualPrice = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.annual_price;
    this.monthlyPrice = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.monthly_price;
    this.downpayment = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.downpayment;
    this.installments = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.number_of_installments;
    this.showTotalPremium = !!((_a = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.price_details) === null || _a === void 0 ? void 0 : _a.new_total_premium);
    if (!!(quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.annual_price)) {
      this.setAnnual(quoteInfo);
    }
    else if (!!(quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.semiannual_price)) {
      this.setSemiAnnual(quoteInfo);
    }
    this.updateTotalPremium(quoteInfo);
  }
  setAnnual(quoteInfo) {
    this.price = quoteInfo.annual_price;
    this.termLength = 'year';
  }
  setSemiAnnual(quoteInfo) {
    this.price = quoteInfo.semiannual_price;
    this.termLength = '6-month policy term';
  }
  updateTotalPremium(quoteInfo) {
    var _a;
    if (!!((_a = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.price_details) === null || _a === void 0 ? void 0 : _a.new_total_premium)) {
      this.totalPremium =
        typeof quoteInfo.price_details.new_total_premium === 'number'
          ? ox(quoteInfo.price_details.new_total_premium)
          : quoteInfo.price_details.new_total_premium.replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    }
    else {
      this.totalPremium = this.price;
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-premium-container", { quoteInfo: this.quoteInfo });
  }
  renderInternal() {
    return (h("bp-sdk-quote-request-premium", { annualPrice: this.annualPrice, downpayment: this.downpayment, installments: this.installments, monthlyPrice: this.monthlyPrice, price: this.price, showTotalPremium: this.showTotalPremium, termLength: this.termLength, totalPremium: this.totalPremium }));
  }
  static get watchers() { return {
    "quoteInfo": ["onQuoteInfoChange"]
  }; }
};
BpSdkQuoteRequestPremiumContainer.style = bpSdkQuoteRequestPremiumContainerCss;

const bpSdkQuoteRequestProductListCss = "";

let BpSdkQuoteRequestProductList = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Product list
     */
    this.products = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-product-list');
    customElements.whenDefined('bp-sdk-external-quote-request-product-list').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-product-list", { products: this.products });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-product-list__container bp-sdk-online-quote__products bp-sdk-quote__products" }, this.products.map((product) => (h("bp-sdk-quote-request-product-container", { product: product })))));
  }
};
BpSdkQuoteRequestProductList.style = bpSdkQuoteRequestProductListCss;

const bpSdkQuoteRequestProductListContainerCss = "";

let BpSdkQuoteRequestProductListContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Product list
     */
    this.products = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-product-list-container');
    customElements.whenDefined('bp-sdk-external-quote-request-product-list-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-product-list-container", { products: this.products });
  }
  renderInternal() {
    return h("bp-sdk-quote-request-product-list", { products: this.products });
  }
};
BpSdkQuoteRequestProductListContainer.style = bpSdkQuoteRequestProductListContainerCss;

const bpSdkQuoteRequestStatusListCss = "";

let BpSdkQuoteRequestStatusList = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-status-list');
    customElements.whenDefined('bp-sdk-external-quote-request-status-list').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-status-list", { isConsumerSelected: this.isConsumerSelected, isExpired: this.isExpired, isFocused: this.isFocused, isRecommended: this.isRecommended, isSelected: this.isSelected }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-status-list__container bp-sdk-online-quote-statuses-container bp-sdk-quote-statuses-container" }, this.isRecommended && h("bp-sdk-chip", { type: "recommended", text: "Recommended" }), this.isSelected && h("bp-sdk-chip", { type: "selected", text: "Selected" }), this.isConsumerSelected && h("bp-sdk-chip", { type: "consumer_selected", text: "Consumer Selected" }), this.isFocused && h("bp-sdk-chip", { type: "focused", text: "Last Viewed" }), this.isExpired && h("bp-sdk-chip", { type: "expired", text: "Expired" })));
  }
};
BpSdkQuoteRequestStatusList.style = bpSdkQuoteRequestStatusListCss;

const bpSdkQuoteRequestStatusListContainerCss = "";

let BpSdkQuoteRequestStatusListContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
    this.isConsumerSelected = false;
    this.isExpired = false;
    this.isFocused = false;
    this.isRecommended = false;
    this.isSelected = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-status-list-container');
    customElements.whenDefined('bp-sdk-external-quote-request-status-list-container').then(() => {
      this.useExternal = true;
    });
    this.onQuoteStatusChange(this.quoteStatus);
  }
  onQuoteStatusChange(quoteStatus) {
    this.isConsumerSelected = !!(quoteStatus === null || quoteStatus === void 0 ? void 0 : quoteStatus.consumer_selected);
    this.isExpired = !!(quoteStatus === null || quoteStatus === void 0 ? void 0 : quoteStatus.expired);
    this.isFocused = !!(quoteStatus === null || quoteStatus === void 0 ? void 0 : quoteStatus.focused);
    this.isRecommended = !!(quoteStatus === null || quoteStatus === void 0 ? void 0 : quoteStatus.recommended);
    this.isSelected = !!(quoteStatus === null || quoteStatus === void 0 ? void 0 : quoteStatus.selected);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-status-list-container", { quoteStatus: this.quoteStatus });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-status-list-container__container" }, h("bp-sdk-quote-request-status-list", { isConsumerSelected: this.isConsumerSelected, isExpired: this.isExpired, isFocused: this.isFocused, isRecommended: this.isRecommended, isSelected: this.isSelected })));
  }
  static get watchers() { return {
    "quoteStatus": ["onQuoteStatusChange"]
  }; }
};
BpSdkQuoteRequestStatusListContainer.style = bpSdkQuoteRequestStatusListContainerCss;

const bpSdkQuoteRequestTaxesAndFeesCss = "";

let BpSdkQuoteRequestTaxesAndFees = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * fees
     */
    this.fees = [];
    /**
     * taxes
     */
    this.taxes = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-taxes-and-fees');
    customElements.whenDefined('bp-sdk-external-quote-request-taxes-and-fees').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-taxes-and-fees", { "disclaimer-html": this.disclaimerHtml, fees: this.fees, taxes: this.taxes });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-taxes-and-fees__container" }, h("div", { class: "bp-sdk-quote-request-taxes-and-fees--subtotal" }, h("div", null, "Taxes and fees included in your premium"), h("bp-sdk-quote-request-fees", { fees: this.taxes, description: 'taxes' }), h("bp-sdk-quote-request-fees", { fees: this.fees, description: 'fees' })), !!this.disclaimerHtml && (h("div", { class: "bp-sdk-quote-request-taxes-and-fees--disclaimer-container" }, h("div", { class: "bp-sdk-quote-request-taxes-and-fees--disclaimer bp-sdk-quote-request--disclaimer", innerHTML: this.disclaimerHtml })))));
  }
};
BpSdkQuoteRequestTaxesAndFees.style = bpSdkQuoteRequestTaxesAndFeesCss;

const bpSdkQuoteRequestTaxesAndFeesContainerCss = "";

let BpSdkQuoteRequestTaxesAndFeesContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
    this.fees = [];
    this.taxes = [];
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-taxes-and-fees-container');
    customElements.whenDefined('bp-sdk-external-quote-request-taxes-and-fees-container').then(() => {
      this.useExternal = true;
    });
    this.onQuoteInfoChange(this.quoteInfo);
  }
  onQuoteInfoChange(quoteInfo) {
    var _a, _b, _c, _d, _e;
    this.disclaimerHtml = (_a = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.price_details) === null || _a === void 0 ? void 0 : _a.disclaimer_html;
    this.taxes = (_c = (_b = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.price_details) === null || _b === void 0 ? void 0 : _b.taxes) !== null && _c !== void 0 ? _c : [];
    this.fees = (_e = (_d = quoteInfo === null || quoteInfo === void 0 ? void 0 : quoteInfo.price_details) === null || _d === void 0 ? void 0 : _d.fees) !== null && _e !== void 0 ? _e : [];
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-taxes-and-fees-container", { quoteInfo: this.quoteInfo });
  }
  renderInternal() {
    return h("bp-sdk-quote-request-taxes-and-fees", { disclaimerHtml: this.disclaimerHtml, fees: this.fees, taxes: this.taxes });
  }
  static get watchers() { return {
    "quoteInfo": ["onQuoteInfoChange"]
  }; }
};
BpSdkQuoteRequestTaxesAndFeesContainer.style = bpSdkQuoteRequestTaxesAndFeesContainerCss;

export { BpSdkQuoteRequestBindContainer as bp_sdk_quote_request_bind_container, BpSdkQuoteRequestButtonContainer as bp_sdk_quote_request_button_container, BpSdkQuoteRequestHeader as bp_sdk_quote_request_header, BpSdkQuoteRequestHeaderContainer as bp_sdk_quote_request_header_container, BpSdkQuoteRequestPremium as bp_sdk_quote_request_premium, BpSdkQuoteRequestPremiumContainer as bp_sdk_quote_request_premium_container, BpSdkQuoteRequestProductList as bp_sdk_quote_request_product_list, BpSdkQuoteRequestProductListContainer as bp_sdk_quote_request_product_list_container, BpSdkQuoteRequestStatusList as bp_sdk_quote_request_status_list, BpSdkQuoteRequestStatusListContainer as bp_sdk_quote_request_status_list_container, BpSdkQuoteRequestTaxesAndFees as bp_sdk_quote_request_taxes_and_fees, BpSdkQuoteRequestTaxesAndFeesContainer as bp_sdk_quote_request_taxes_and_fees_container };
