import { EventEmitter } from '../../stencil-public-runtime';
import { IDateInputComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkDateInput implements IDateInputComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question Id
   */
  questionId: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * Question text
   */
  text: string;
  /**
   * minimum date value
   */
  minDate: string;
  /**
   * maximum date value
   */
  maxDate: string;
  /**
   * question code
   */
  code: string;
  /**
   * question value
   */
  value: string;
  /**
   * Placeholder to display
   */
  placeholder: string;
  /**
   * Label id to use
   */
  labelId: string;
  /**
   * Regex pattern to match
   */
  pattern: string;
  /**
   * Is touched
   */
  touched: boolean;
  /**
   * Is pristine
   */
  pristine: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Error messages
   */
  errors: string[];
  /**
   * Error text
   */
  errorText: string;
  /**
   * Is sensitive
   */
  isSensitive: boolean;
  /**
   * Label to use
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Is required
   */
  required: boolean;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  _labelledBy: string;
  _value: string;
  useExternal: boolean;
  /**
   * Value has updated
   */
  valueUpdate: EventEmitter<string>;
  el: HTMLInputElement;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  componentDidLoad(): void;
  getDatePicker(): any;
  onAriaLabelledByChange(labelId: string): void;
  onLabelledByChange(labelledBy: string): void;
  updateLabelledBy(aria: string, ids: string): void;
  onValueChange(newValue: string): void;
  onChange(event: Event): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
  renderInput(): any;
  renderReadOnlyElement(value: string): any;
}
