import { IDriverGroupComponent, IErrorState, IMappedQuestionGroupAnswers } from '@boldpenguin/sdk-types';
import { EventEmitter } from '../../stencil-public-runtime';
export declare class BpSdkDriverGroup implements IDriverGroupComponent {
  /**
   * Question Group
   */
  group: IMappedQuestionGroupAnswers;
  /**
   * Can delete
   */
  canDelete: boolean;
  /**
   * Error states
   */
  errors: IErrorState;
  isDriverValid: boolean;
  driverName: string;
  labelId: string;
  useExternal: boolean;
  isExpanded: boolean;
  private slotId;
  /**
   * Delete item event
   */
  deleteItem: EventEmitter<void>;
  onGroupChange(group: IMappedQuestionGroupAnswers): void;
  onErrorsChange(errors: IErrorState): void;
  updateDriverName(group: IMappedQuestionGroupAnswers): void;
  updateDriverValidity(group: IMappedQuestionGroupAnswers, errors: IErrorState): void;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  onToggleExpansion: () => void;
  render(): any[];
  renderExternal(): any;
  onDeleteButtonClick: () => CustomEvent<void>;
  renderInternal(): any;
}
