import { BpSdkStore, getCurrentActiveQuestionSet, removeActiveAnswerId, saveQuestionSet, switchActiveQuestionSet, pushAnswer, updateErrors } from '@boldpenguin/sdk-redux';
import { IAnalyticsTrackEventDetail, IAnswer, IApplicationFormProcesses, IApplicationFormQuestionSet, INextButtonContainerComponent, IPartnerEngineConfig, IQuestionSetState, LoadingStates } from '@boldpenguin/sdk-types';
import { EventEmitter } from '../../stencil-public-runtime';
import { Unsubscribe } from '@stencil/redux';
export declare class BpSdkNextButtonContainer implements INextButtonContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  updateErrors: typeof updateErrors;
  removeActiveAnswerId: typeof removeActiveAnswerId;
  saveQuestionSet: typeof saveQuestionSet;
  switchActiveQuestionSet: typeof switchActiveQuestionSet;
  getCurrentActiveQuestionSet: typeof getCurrentActiveQuestionSet;
  pushAnswer: typeof pushAnswer;
  activeQuestionSet: IApplicationFormQuestionSet;
  /**
   * Controls disabled state of button
   */
  buttonDisabled: boolean;
  /**
   * IPartnerEngineConfig injected from redux
   */
  config: IPartnerEngineConfig;
  /**
   * Answer queue
   */
  queue: IAnswer[];
  /**
   * Disable navigation if active question set is incomplete
   */
  shouldDisableIfIncomplete: boolean;
  /**
   * Answer resource states injected from redux
   */
  answersResourceState: LoadingStates;
  /**
   * Application form resource states injected from redux
   */
  applicationFormResourceState: LoadingStates;
  /**
   * Question pool resource states injected from redux
   */
  questionPoolResourceState: LoadingStates;
  /**
   * Question set resource states injected from redux
   */
  questionSetResourceState: LoadingStates;
  /**
   * Question Set State from Store
   */
  questionSetState: IQuestionSetState;
  /**
   * Application form state injected from redux
   */
  locked: boolean;
  /**
   * Pending processes of application form state injected from redux
   */
  pendingProcesses: IApplicationFormProcesses[];
  /**
   * Is owner of application
   */
  isOwner: boolean;
  /**
   * Has permission to edit application
   */
  hasPermissionToEdit: boolean;
  /**
   * Enabled user check for application
   */
  enableUserApplicationGuard: boolean;
  /**
   * Emits an analytics tracking event, see `AnalyticsTrackingEventName` (sdk-types) for event names
   */
  bpAnalyticsTrack: EventEmitter<IAnalyticsTrackEventDetail>;
  useExternal: boolean;
  canSave: boolean;
  areResourcesReady: boolean;
  isDisabled: boolean;
  caDisabled: boolean;
  isReady: boolean;
  isLocked: boolean;
  isFirstRun: boolean;
  classes: string;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  onEnableUserApplicationGuard(enableUserApplicationGuard: boolean): void;
  onHasPermissionToEdit(hasPermission: boolean): void;
  onIsOwner(isOwner: boolean): void;
  onLocked(locked: boolean): void;
  updateIsLocked(locked: boolean, isOwner: boolean, hasPermission: boolean, enableUserApplicationGuard: boolean): void;
  onIsFirstRun(isFirstRun: boolean): void;
  onIsReady(isReady: boolean): void;
  updateAreResourcesReady(isFirstRun: boolean, isReady: boolean): void;
  onAnswersResourcesStateChange(state: LoadingStates): void;
  onApplicationFormResourceStateChange(state: LoadingStates): void;
  onQuestionPoolResourcesStateChange(state: LoadingStates): void;
  onQuestionSetResourcesStateChange(state: LoadingStates): void;
  calculateResourcesReady(resources?: {
    answers?: LoadingStates;
    applicationForm?: LoadingStates;
    questionPools?: LoadingStates;
    questionSets?: LoadingStates;
  }): boolean;
  onShouldDisableIfIncompleteChange(shouldDisableIfIncomplete: boolean): void;
  onActiveQuestionSetChange(activeQuestionSet: IApplicationFormQuestionSet): void;
  onQueueChange(queue: IAnswer[]): void;
  onPendingProcessesChange(processes: IApplicationFormProcesses[]): void;
  disableIfCAQuestionSet(shouldDisableIfIncomplete: boolean, activeQuestionSet: IApplicationFormQuestionSet): void;
  updateOnDisableIfIncomplete(shouldDisableIfIncomplete: boolean, activeQuestionSet: IApplicationFormQuestionSet): void;
  mapStateToProps: (state: BpSdkStore) => {
    activeQuestionSet: IApplicationFormQuestionSet;
    config: IPartnerEngineConfig;
    answersResourceState: LoadingStates;
    applicationFormResourceState: LoadingStates;
    pendingProcesses: IApplicationFormProcesses[];
    questionPoolResourceState: LoadingStates;
    questionSetResourceState: LoadingStates;
    questionSetState: IQuestionSetState;
    queue: IAnswer[];
    enableUserApplicationGuard: boolean;
    locked: boolean;
    isOwner: boolean;
    hasPermissionToEdit: boolean;
  };
  render(): any[];
  renderExternal(): any;
  handleSaveQuestionSet(): void;
  renderInternal(): any;
  private doesCurrentQuestionSetHaveAPendingProcess;
  private parentQuestionSetCanSave;
  private callSaveQuestionSet;
  private handleStep;
}
