import { EventEmitter } from '../../stencil-public-runtime';
import { IChoice, IRadioInputComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkRadioInput implements IRadioInputComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question id
   */
  questionId: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * question code
   */
  code: string;
  /**
   * Label to display
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Choices to display
   */
  choices: IChoice[];
  /**
   * Selected choice
   */
  choiceId: string;
  /**
   * Error messages
   */
  errors: string[];
  /**
   * Error text
   */
  errorText: string;
  /**
   * Is touched
   */
  touched: boolean;
  /**
   * Is pristine
   */
  pristine: boolean;
  /**
   * Is required
   */
  required: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  controlClasses: string;
  _choiceId: string;
  useExternal: boolean;
  valueUpdate: EventEmitter<string>;
  removeActiveAnswer: EventEmitter<void>;
  el: HTMLElement;
  onControlChange(): void;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  onChoiceIdChange(newValue: string): void;
  onChange(new_value: string): void;
  renderChoice(choice: IChoice): any;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
  renderReadOnlyElement(value: string): any;
}
